/*
 * Copyright (c) 2001-2005 Servertec. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * THIS NOTICE MUST NOT BE ALTERED NOR REMOVED.
 *
 * CopyrightVersion 1.0
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class RegistryExplorer_MessageDialog extends JDialog implements ActionListener
{
	JPanel panel1 = new JPanel();
	JPanel insetsPanel1 = new JPanel();
	JButton buttonOk = new JButton();
	BorderLayout borderLayout1 = new BorderLayout();

	ImageIcon warning_icon = new ImageIcon(RegistryExplorer.class.getResource("/icons/warning.gif"));
	JPanel jPanel1 = new JPanel();
	JPanel jPanel3 = new JPanel();
	JButton jButton1 = new JButton();
	JPanel jPanel2 = new JPanel();
	GridBagLayout gridBagLayout1 = new GridBagLayout();
	JTextField jTextFieldMessage = new JTextField();

	public RegistryExplorer_MessageDialog(Frame parent)
	{
		super(parent);
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try
		{
			jbInit();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		pack();
	}
	/**Component initialization*/
	private void jbInit() throws Exception
	{
		//imageLabel.setIcon(new ImageIcon(RegistryExplorer_MessageDialog.class.getResource("[Your Image]")));
		this.setTitle("Warning");
		this.addComponentListener(new java.awt.event.ComponentAdapter()
		{
			public void componentShown(ComponentEvent e)
			{
				this_componentShown(e);
			}
		});
		setResizable(false);
		this.setModal(true);
		panel1.setLayout(borderLayout1);
		buttonOk.setText("Ok");
		buttonOk.addKeyListener(new java.awt.event.KeyAdapter()
		{
			public void keyTyped(KeyEvent e)
			{
				buttonOk_keyTyped(e);
			}
		});
		buttonOk.addActionListener(this);
		jButton1.setBorder(null);
		jButton1.setIcon(warning_icon);
		jPanel3.setLayout(null);
		jPanel1.setLayout(gridBagLayout1);
		jTextFieldMessage.setBackground(Color.lightGray);
		jTextFieldMessage.setEnabled(false);
		jTextFieldMessage.setBorder(null);
		jTextFieldMessage.setOpaque(false);
		jTextFieldMessage.setDisabledTextColor(Color.black);
		jTextFieldMessage.setEditable(false);
		jTextFieldMessage.setSelectedTextColor(Color.lightGray);
		jPanel1.setMinimumSize(new Dimension(325, 55));
		jPanel1.setPreferredSize(new Dimension(325, 55));
		this.getContentPane().add(panel1, BorderLayout.SOUTH);
		panel1.add(insetsPanel1, BorderLayout.NORTH);
		insetsPanel1.add(buttonOk, null);
		this.getContentPane().add(jPanel1, BorderLayout.NORTH);
		jPanel1.add(jPanel3, new GridBagConstraints(0, 0, 1, 5, 1.0, 1.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 3), 27, 51));
		jPanel1.add(jButton1, new GridBagConstraints(1, 0, 1, 2, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 2, 1), 6, 9));
		jPanel1.add(jPanel2, new GridBagConstraints(4, 0, 1, 9, 1.0, 1.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(3, 0, 0, 0), 18, 43));
		jPanel1.add(jTextFieldMessage, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
			,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(9, 12, 18, 0), 191, 0));
	}
	/**Overridden so we can exit when window is closed*/
	protected void processWindowEvent(WindowEvent e)
	{
		if (e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			cancel();
		}
		super.processWindowEvent(e);
	}
	/**Close the dialog*/
	void cancel()
	{
		hide();
	}
	/**Close the dialog on a button event*/
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == buttonOk)
		{
			cancel();
		}
	}

	void buttonOk_keyTyped(KeyEvent e)
	{
		char chr = e.getKeyChar();
		if(chr == ' ' || chr == '\n')
		{
			cancel();
		}
		else if(chr == 27)
		{
			cancel();
		}
	}

	void this_componentShown(ComponentEvent e)
	{
		buttonOk.grabFocus();
	}
}